# coding: utf-8

"""
    Pluxbox Radiomanager Client

    Pluxbox RadioManager gives you the power, flexibility and speed you always wanted in a lightweight and easy-to-use web-based radio solution. With Pluxbox RadioManager you can organise your radio workflow and automate your omnichannel communication with your listeners. We offer wide range specialised services for the radio and connections like Hybrid Radio, Visual Radio, your website and social media without losing focus on your broadcast. For more information visit https://pluxbox.com

    OpenAPI spec version: 2.0
    Contact: support@pluxbox.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ItemRelations(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'block': 'ItemRelationsBlock',
        'broadcast': 'BlockRelationsBroadcast',
        'program': 'ItemRelationsProgram',
        'contacts': 'ItemRelationsContacts',
        'tags': 'ItemRelationsTags',
        'campaign': 'ItemRelationsCampaign',
        'model_type': 'BroadcastRelationsModelType'
    }

    attribute_map = {
        'block': 'block',
        'broadcast': 'broadcast',
        'program': 'program',
        'contacts': 'contacts',
        'tags': 'tags',
        'campaign': 'campaign',
        'model_type': 'model_type'
    }

    def __init__(self, block=None, broadcast=None, program=None, contacts=None, tags=None, campaign=None, model_type=None):
        """
        ItemRelations - a model defined in Swagger
        """

        self._block = None
        self._broadcast = None
        self._program = None
        self._contacts = None
        self._tags = None
        self._campaign = None
        self._model_type = None

        if block is not None:
          self.block = block
        if broadcast is not None:
          self.broadcast = broadcast
        if program is not None:
          self.program = program
        if contacts is not None:
          self.contacts = contacts
        if tags is not None:
          self.tags = tags
        if campaign is not None:
          self.campaign = campaign
        if model_type is not None:
          self.model_type = model_type

    @property
    def block(self):
        """
        Gets the block of this ItemRelations.

        :return: The block of this ItemRelations.
        :rtype: ItemRelationsBlock
        """
        return self._block

    @block.setter
    def block(self, block):
        """
        Sets the block of this ItemRelations.

        :param block: The block of this ItemRelations.
        :type: ItemRelationsBlock
        """

        self._block = block

    @property
    def broadcast(self):
        """
        Gets the broadcast of this ItemRelations.

        :return: The broadcast of this ItemRelations.
        :rtype: BlockRelationsBroadcast
        """
        return self._broadcast

    @broadcast.setter
    def broadcast(self, broadcast):
        """
        Sets the broadcast of this ItemRelations.

        :param broadcast: The broadcast of this ItemRelations.
        :type: BlockRelationsBroadcast
        """

        self._broadcast = broadcast

    @property
    def program(self):
        """
        Gets the program of this ItemRelations.

        :return: The program of this ItemRelations.
        :rtype: ItemRelationsProgram
        """
        return self._program

    @program.setter
    def program(self, program):
        """
        Sets the program of this ItemRelations.

        :param program: The program of this ItemRelations.
        :type: ItemRelationsProgram
        """

        self._program = program

    @property
    def contacts(self):
        """
        Gets the contacts of this ItemRelations.

        :return: The contacts of this ItemRelations.
        :rtype: ItemRelationsContacts
        """
        return self._contacts

    @contacts.setter
    def contacts(self, contacts):
        """
        Sets the contacts of this ItemRelations.

        :param contacts: The contacts of this ItemRelations.
        :type: ItemRelationsContacts
        """

        self._contacts = contacts

    @property
    def tags(self):
        """
        Gets the tags of this ItemRelations.

        :return: The tags of this ItemRelations.
        :rtype: ItemRelationsTags
        """
        return self._tags

    @tags.setter
    def tags(self, tags):
        """
        Sets the tags of this ItemRelations.

        :param tags: The tags of this ItemRelations.
        :type: ItemRelationsTags
        """

        self._tags = tags

    @property
    def campaign(self):
        """
        Gets the campaign of this ItemRelations.

        :return: The campaign of this ItemRelations.
        :rtype: ItemRelationsCampaign
        """
        return self._campaign

    @campaign.setter
    def campaign(self, campaign):
        """
        Sets the campaign of this ItemRelations.

        :param campaign: The campaign of this ItemRelations.
        :type: ItemRelationsCampaign
        """

        self._campaign = campaign

    @property
    def model_type(self):
        """
        Gets the model_type of this ItemRelations.

        :return: The model_type of this ItemRelations.
        :rtype: BroadcastRelationsModelType
        """
        return self._model_type

    @model_type.setter
    def model_type(self, model_type):
        """
        Sets the model_type of this ItemRelations.

        :param model_type: The model_type of this ItemRelations.
        :type: BroadcastRelationsModelType
        """

        self._model_type = model_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ItemRelations):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
