# coding: utf-8

"""
    Pluxbox Radiomanager Client

    Pluxbox RadioManager gives you the power, flexibility and speed you always wanted in a lightweight and easy-to-use web-based radio solution. With Pluxbox RadioManager you can organise your radio workflow and automate your omnichannel communication with your listeners. We offer wide range specialised services for the radio and connections like Hybrid Radio, Visual Radio, your website and social media without losing focus on your broadcast. For more information visit https://pluxbox.com

    OpenAPI spec version: 2.0
    Contact: support@pluxbox.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class ModelTypeResult(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'id': 'int',
        'name': 'str',
        'model': 'str',
        'created_at': 'datetime',
        'updated_at': 'datetime',
        'options': 'ModelTypeOptions',
        'order': 'int',
        'deleted_at': 'datetime',
        'campaigns': 'ModelTypeRelationsCampaigns',
        'broadcasts': 'ModelTypeRelationsBroadcasts',
        'programs': 'ModelTypeRelationsPrograms',
        'contacts': 'ModelTypeRelationsContacts',
        'presenters': 'ModelTypeRelationsPresenters',
        'items': 'ModelTypeRelationsItems',
        'external_station_id': 'int'
    }

    attribute_map = {
        'id': 'id',
        'name': 'name',
        'model': 'model',
        'created_at': 'created_at',
        'updated_at': 'updated_at',
        'options': 'options',
        'order': 'order',
        'deleted_at': 'deleted_at',
        'campaigns': 'campaigns',
        'broadcasts': 'broadcasts',
        'programs': 'programs',
        'contacts': 'contacts',
        'presenters': 'presenters',
        'items': 'items',
        'external_station_id': '_external_station_id'
    }

    def __init__(self, id=None, name=None, model=None, created_at=None, updated_at=None, options=None, order=None, deleted_at=None, campaigns=None, broadcasts=None, programs=None, contacts=None, presenters=None, items=None, external_station_id=None):
        """
        ModelTypeResult - a model defined in Swagger
        """

        self._id = None
        self._name = None
        self._model = None
        self._created_at = None
        self._updated_at = None
        self._options = None
        self._order = None
        self._deleted_at = None
        self._campaigns = None
        self._broadcasts = None
        self._programs = None
        self._contacts = None
        self._presenters = None
        self._items = None
        self._external_station_id = None

        self.id = id
        if name is not None:
          self.name = name
        if model is not None:
          self.model = model
        if created_at is not None:
          self.created_at = created_at
        if updated_at is not None:
          self.updated_at = updated_at
        if options is not None:
          self.options = options
        if order is not None:
          self.order = order
        if deleted_at is not None:
          self.deleted_at = deleted_at
        if campaigns is not None:
          self.campaigns = campaigns
        if broadcasts is not None:
          self.broadcasts = broadcasts
        if programs is not None:
          self.programs = programs
        if contacts is not None:
          self.contacts = contacts
        if presenters is not None:
          self.presenters = presenters
        if items is not None:
          self.items = items
        if external_station_id is not None:
          self.external_station_id = external_station_id

    @property
    def id(self):
        """
        Gets the id of this ModelTypeResult.

        :return: The id of this ModelTypeResult.
        :rtype: int
        """
        return self._id

    @id.setter
    def id(self, id):
        """
        Sets the id of this ModelTypeResult.

        :param id: The id of this ModelTypeResult.
        :type: int
        """
        if id is None:
            raise ValueError("Invalid value for `id`, must not be `None`")

        self._id = id

    @property
    def name(self):
        """
        Gets the name of this ModelTypeResult.

        :return: The name of this ModelTypeResult.
        :rtype: str
        """
        return self._name

    @name.setter
    def name(self, name):
        """
        Sets the name of this ModelTypeResult.

        :param name: The name of this ModelTypeResult.
        :type: str
        """

        self._name = name

    @property
    def model(self):
        """
        Gets the model of this ModelTypeResult.

        :return: The model of this ModelTypeResult.
        :rtype: str
        """
        return self._model

    @model.setter
    def model(self, model):
        """
        Sets the model of this ModelTypeResult.

        :param model: The model of this ModelTypeResult.
        :type: str
        """
        allowed_values = ["broadcast", "program", "item", "campaign", "presenter", "contact", "external"]
        if model not in allowed_values:
            raise ValueError(
                "Invalid value for `model` ({0}), must be one of {1}"
                .format(model, allowed_values)
            )

        self._model = model

    @property
    def created_at(self):
        """
        Gets the created_at of this ModelTypeResult.

        :return: The created_at of this ModelTypeResult.
        :rtype: datetime
        """
        return self._created_at

    @created_at.setter
    def created_at(self, created_at):
        """
        Sets the created_at of this ModelTypeResult.

        :param created_at: The created_at of this ModelTypeResult.
        :type: datetime
        """

        self._created_at = created_at

    @property
    def updated_at(self):
        """
        Gets the updated_at of this ModelTypeResult.

        :return: The updated_at of this ModelTypeResult.
        :rtype: datetime
        """
        return self._updated_at

    @updated_at.setter
    def updated_at(self, updated_at):
        """
        Sets the updated_at of this ModelTypeResult.

        :param updated_at: The updated_at of this ModelTypeResult.
        :type: datetime
        """

        self._updated_at = updated_at

    @property
    def options(self):
        """
        Gets the options of this ModelTypeResult.

        :return: The options of this ModelTypeResult.
        :rtype: ModelTypeOptions
        """
        return self._options

    @options.setter
    def options(self, options):
        """
        Sets the options of this ModelTypeResult.

        :param options: The options of this ModelTypeResult.
        :type: ModelTypeOptions
        """

        self._options = options

    @property
    def order(self):
        """
        Gets the order of this ModelTypeResult.

        :return: The order of this ModelTypeResult.
        :rtype: int
        """
        return self._order

    @order.setter
    def order(self, order):
        """
        Sets the order of this ModelTypeResult.

        :param order: The order of this ModelTypeResult.
        :type: int
        """

        self._order = order

    @property
    def deleted_at(self):
        """
        Gets the deleted_at of this ModelTypeResult.

        :return: The deleted_at of this ModelTypeResult.
        :rtype: datetime
        """
        return self._deleted_at

    @deleted_at.setter
    def deleted_at(self, deleted_at):
        """
        Sets the deleted_at of this ModelTypeResult.

        :param deleted_at: The deleted_at of this ModelTypeResult.
        :type: datetime
        """

        self._deleted_at = deleted_at

    @property
    def campaigns(self):
        """
        Gets the campaigns of this ModelTypeResult.

        :return: The campaigns of this ModelTypeResult.
        :rtype: ModelTypeRelationsCampaigns
        """
        return self._campaigns

    @campaigns.setter
    def campaigns(self, campaigns):
        """
        Sets the campaigns of this ModelTypeResult.

        :param campaigns: The campaigns of this ModelTypeResult.
        :type: ModelTypeRelationsCampaigns
        """

        self._campaigns = campaigns

    @property
    def broadcasts(self):
        """
        Gets the broadcasts of this ModelTypeResult.

        :return: The broadcasts of this ModelTypeResult.
        :rtype: ModelTypeRelationsBroadcasts
        """
        return self._broadcasts

    @broadcasts.setter
    def broadcasts(self, broadcasts):
        """
        Sets the broadcasts of this ModelTypeResult.

        :param broadcasts: The broadcasts of this ModelTypeResult.
        :type: ModelTypeRelationsBroadcasts
        """

        self._broadcasts = broadcasts

    @property
    def programs(self):
        """
        Gets the programs of this ModelTypeResult.

        :return: The programs of this ModelTypeResult.
        :rtype: ModelTypeRelationsPrograms
        """
        return self._programs

    @programs.setter
    def programs(self, programs):
        """
        Sets the programs of this ModelTypeResult.

        :param programs: The programs of this ModelTypeResult.
        :type: ModelTypeRelationsPrograms
        """

        self._programs = programs

    @property
    def contacts(self):
        """
        Gets the contacts of this ModelTypeResult.

        :return: The contacts of this ModelTypeResult.
        :rtype: ModelTypeRelationsContacts
        """
        return self._contacts

    @contacts.setter
    def contacts(self, contacts):
        """
        Sets the contacts of this ModelTypeResult.

        :param contacts: The contacts of this ModelTypeResult.
        :type: ModelTypeRelationsContacts
        """

        self._contacts = contacts

    @property
    def presenters(self):
        """
        Gets the presenters of this ModelTypeResult.

        :return: The presenters of this ModelTypeResult.
        :rtype: ModelTypeRelationsPresenters
        """
        return self._presenters

    @presenters.setter
    def presenters(self, presenters):
        """
        Sets the presenters of this ModelTypeResult.

        :param presenters: The presenters of this ModelTypeResult.
        :type: ModelTypeRelationsPresenters
        """

        self._presenters = presenters

    @property
    def items(self):
        """
        Gets the items of this ModelTypeResult.

        :return: The items of this ModelTypeResult.
        :rtype: ModelTypeRelationsItems
        """
        return self._items

    @items.setter
    def items(self, items):
        """
        Sets the items of this ModelTypeResult.

        :param items: The items of this ModelTypeResult.
        :type: ModelTypeRelationsItems
        """

        self._items = items

    @property
    def external_station_id(self):
        """
        Gets the external_station_id of this ModelTypeResult.

        :return: The external_station_id of this ModelTypeResult.
        :rtype: int
        """
        return self._external_station_id

    @external_station_id.setter
    def external_station_id(self, external_station_id):
        """
        Sets the external_station_id of this ModelTypeResult.

        :param external_station_id: The external_station_id of this ModelTypeResult.
        :type: int
        """

        self._external_station_id = external_station_id

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, ModelTypeResult):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
