# coding: utf-8

"""
    Pluxbox Radiomanager Client

    Pluxbox RadioManager gives you the power, flexibility and speed you always wanted in a lightweight and easy-to-use web-based radio solution. With Pluxbox RadioManager you can organise your radio workflow and automate your omnichannel communication with your listeners. We offer wide range specialised services for the radio and connections like Hybrid Radio, Visual Radio, your website and social media without losing focus on your broadcast. For more information visit https://pluxbox.com

    OpenAPI spec version: 2.0
    Contact: support@pluxbox.com
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""


from pprint import pformat
from six import iteritems
import re


class PresenterRelations(object):
    """
    NOTE: This class is auto generated by the swagger code generator program.
    Do not edit the class manually.
    """


    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'programs': 'PresenterRelationsPrograms',
        'broadcasts': 'PresenterRelationsBroadcasts',
        'model_type': 'BroadcastRelationsModelType'
    }

    attribute_map = {
        'programs': 'programs',
        'broadcasts': 'broadcasts',
        'model_type': 'model_type'
    }

    def __init__(self, programs=None, broadcasts=None, model_type=None):
        """
        PresenterRelations - a model defined in Swagger
        """

        self._programs = None
        self._broadcasts = None
        self._model_type = None

        if programs is not None:
          self.programs = programs
        if broadcasts is not None:
          self.broadcasts = broadcasts
        if model_type is not None:
          self.model_type = model_type

    @property
    def programs(self):
        """
        Gets the programs of this PresenterRelations.

        :return: The programs of this PresenterRelations.
        :rtype: PresenterRelationsPrograms
        """
        return self._programs

    @programs.setter
    def programs(self, programs):
        """
        Sets the programs of this PresenterRelations.

        :param programs: The programs of this PresenterRelations.
        :type: PresenterRelationsPrograms
        """

        self._programs = programs

    @property
    def broadcasts(self):
        """
        Gets the broadcasts of this PresenterRelations.

        :return: The broadcasts of this PresenterRelations.
        :rtype: PresenterRelationsBroadcasts
        """
        return self._broadcasts

    @broadcasts.setter
    def broadcasts(self, broadcasts):
        """
        Sets the broadcasts of this PresenterRelations.

        :param broadcasts: The broadcasts of this PresenterRelations.
        :type: PresenterRelationsBroadcasts
        """

        self._broadcasts = broadcasts

    @property
    def model_type(self):
        """
        Gets the model_type of this PresenterRelations.

        :return: The model_type of this PresenterRelations.
        :rtype: BroadcastRelationsModelType
        """
        return self._model_type

    @model_type.setter
    def model_type(self, model_type):
        """
        Sets the model_type of this PresenterRelations.

        :param model_type: The model_type of this PresenterRelations.
        :type: BroadcastRelationsModelType
        """

        self._model_type = model_type

    def to_dict(self):
        """
        Returns the model properties as a dict
        """
        result = {}

        for attr, _ in iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """
        Returns the string representation of the model
        """
        return pformat(self.to_dict())

    def __repr__(self):
        """
        For `print` and `pprint`
        """
        return self.to_str()

    def __eq__(self, other):
        """
        Returns true if both objects are equal
        """
        if not isinstance(other, PresenterRelations):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """
        Returns true if both objects are not equal
        """
        return not self == other
